<?php
	// set up the variables
	$conn = pg_pconnect("host=dumont user=postgres dbname=nag");

	if(!$conn)
	{
		echo pg_errormessage($conn);
		exit;
	}

	function query($sql)
	{
		global $conn;
		return pg_query($conn,$sql);
	}
?>           

<html>
<head>
	<title>tac</title>
</head>

<body>

<table>
<tr>
	<td colspan=2><b>Monitoring Stats</b></td>
</tr>
<?php
	$service_perf_data = query("select min_execute_time,max_execute_time,avg_execute_time,min_latency,max_latency,avg_latency from service_perf_data_mv");
?>
<tr>
	<td>Service Check Execution Time</td>
	<td><?=pg_result($service_perf_data,0,0)?> / <?=pg_result($service_perf_data,0,2)?> / <?=pg_result($service_perf_data,0,1)?></td>
</tr>
<tr>
	<td>Service Check Latency</td>
	<td><?=pg_result($service_perf_data,0,3)?> / <?=pg_result($service_perf_data,0,5)?> / <?=pg_result($service_perf_data,0,4)?></td>
</tr>
<?php
	$host_perf_data = query("select min_execute_time,max_execute_time,avg_execute_time,min_latency,max_latency,avg_latency from host_perf_data_mv");
?>
<tr>
	<td>Host Check Execution Time</td>
	<td><?=pg_result($host_perf_data,0,0)?> / <?=pg_result($host_perf_data,0,2)?> / <?=pg_result($host_perf_data,0,1)?></td>
</tr>
<tr>
	<td>Host Check Latency</td>
	<td><?=pg_result($host_perf_data,0,3)?> / <?=pg_result($host_perf_data,0,5)?> / <?=pg_result($host_perf_data,0,4)?></td>
</tr>
</table>

<table>
<tr>
	<td colspan=4><b>Hosts</b></td>
</tr>
<tr>
	<td>Down</td>
	<td>Unreachable</td>
	<td>Up</td>
	<td>Pending</td>
</tr>
<tr>
<?php
	$host_states = query("select soft_state,count from host_states_mv");
	$row_count = pg_numrows($host_states);
?>
	<td>
<?php
	for($i = 0; $i < $row_count; $i++)
	{
		if(pg_result($host_states,$i,0) == 1)
		{
			echo pg_result($host_states,$i,1);
			break;
		}
	}

	if($i == $row_count) echo "0";
?>
	</td>
	<td>
<?php
	for($i = 0; $i < $row_count; $i++)
	{
		if(pg_result($host_states,$i,0) == 2)
		{
			echo pg_result($host_states,$i,1);
			break;
		}
	}

	if($i == $row_count) echo "0";
?>
	</td>
	<td>
<?php
	for($i = 0; $i < $row_count; $i++)
	{
		if(pg_result($host_states,$i,0) == 0)
		{
			echo pg_result($host_states,$i,1);
			break;
		}
	}

	if($i == $row_count) echo "0";
?>
	</td>
	<td>
<?php
	for($i = 0; $i < $row_count; $i++)
	{
		if(pg_result($host_states,$i,0) == -1)
		{
			echo pg_result($host_states,$i,1);
			break;
		}
	}

	if($i == $row_count) echo "0";
?>
	</td>
</tr>
</table>

<table>
<tr>
	<td colspan=5><b>Services on (ok/problem) hosts</b></td>
</tr>
<tr>
	<td>Critical</td>
	<td>Warning</td>
	<td>Unknown</td>
	<td>Ok</td>
	<td>Pending</td>
</tr>
<tr>
<?php
	$service_states = query("select state,total,good_hosts,bad_hosts from service_states_mv");
	$row_count = pg_numrows($service_states);
?>
	<td>
<?php
	for($i = 0; $i < $row_count; $i++)
	{
		if(pg_result($service_states,$i,0) == 2)
		{
			echo pg_result($service_states,$i,1);
			echo " (";
			echo pg_result($service_states,$i,2);
			echo "/";
			echo pg_result($service_states,$i,3);
			echo ")";
			break;
		}
	}

	if($i == $row_count) echo "0";
?>
	</td>
	<td>
<?php
	for($i = 0; $i < $row_count; $i++)
	{
		if(pg_result($service_states,$i,0) == 1)
		{
			echo pg_result($service_states,$i,1);
			echo " (";
			echo pg_result($service_states,$i,2);
			echo "/";
			echo pg_result($service_states,$i,3);
			echo ")";
			break;
		}
	}

	if($i == $row_count) echo "0";
?>
	</td>
	<td>
<?php
	for($i = 0; $i < $row_count; $i++)
	{
		if(pg_result($service_states,$i,0) == 3)
		{
			echo pg_result($service_states,$i,1);
			echo " (";
			echo pg_result($service_states,$i,2);
			echo "/";
			echo pg_result($service_states,$i,3);
			echo ")";
			break;
		}
	}

	if($i == $row_count) echo "0";
?>
	</td>
	<td>
<?php
	for($i = 0; $i < $row_count; $i++)
	{
		if(pg_result($service_states,$i,0) == 0)
		{
			echo pg_result($service_states,$i,1);
			echo " (";
			echo pg_result($service_states,$i,2);
			echo "/";
			echo pg_result($service_states,$i,3);
			echo ")";
			break;
		}
	}

	if($i == $row_count) echo "0";
?>
	</td>
	<td>
<?php
	for($i = 0; $i < $row_count; $i++)
	{
		if(pg_result($service_states,$i,0) == -1)
		{
			echo pg_result($service_states,$i,1);
			echo " (";
			echo pg_result($service_states,$i,2);
			echo "/";
			echo pg_result($service_states,$i,3);
			echo ")";
			break;
		}
	}

	if($i == $row_count) echo "0";
?>
	</td>
</tr>
</table>


<table>
<tr>
	<td colspan=5><b>Monitoring Features</b></td>
</tr>
<tr>
	<td>Flap Detection</td>
	<td>Notifications</td>
	<td>Event Handlers</td>
	<td>Active Checks</td>
	<td>Passive Checks</td>
</tr>
<?php
	$option_exceptions = query("select type,active,notification,flap,passive,event from option_exceptions_mv order by type");
?>
<tr>
	<td>
<?php
	if(pg_result($option_exceptions,0,3) > 0)
	{
		echo pg_result($option_exceptions,0,3);
		echo " hosts disabled";
	}
	else
	{
		echo "All hosts enabled";
	}
?>
	</td>
	<td>
<?php
	if(pg_result($option_exceptions,0,2) > 0)
	{
		echo pg_result($option_exceptions,0,2);
		echo " hosts disabled";
	}
	else
	{
		echo "All hosts enabled";
	}
?>
	</td>
	<td>
<?php
	if(pg_result($option_exceptions,0,5) > 0)
	{
		echo pg_result($option_exceptions,0,5);
		echo " hosts disabled";
	}
	else
	{
		echo "All hosts enabled";
	}
?>
	</td>
	<td>
<?php
	if(pg_result($option_exceptions,0,1) > 0)
	{
		echo pg_result($option_exceptions,0,1);
		echo " hosts disabled";
	}
	else
	{
		echo "All hosts enabled";
	}
?>
	</td>
	<td>
<?php
	if(pg_result($option_exceptions,0,4) > 0)
	{
		echo pg_result($option_exceptions,0,4);
		echo " hosts disabled";
	}
	else
	{
		echo "All hosts enabled";
	}
?>
	</td>
</tr>
<tr>
	<td>
<?php
	if(pg_result($option_exceptions,1,3) > 0)
	{
		echo pg_result($option_exceptions,1,3);
		echo " services disabled";
	}
	else
	{
		echo "All services enabled";
	}
?>
	</td>
	<td>
<?php
	if(pg_result($option_exceptions,1,2) > 0)
	{
		echo pg_result($option_exceptions,1,2);
		echo " services disabled";
	}
	else
	{
		echo "All services enabled";
	}
?>
	</td>
	<td>
<?php
	if(pg_result($option_exceptions,1,5) > 0)
	{
		echo pg_result($option_exceptions,1,5);
		echo " services disabled";
	}
	else
	{
		echo "All services enabled";
	}
?>
	</td>
	<td>
<?php
	if(pg_result($option_exceptions,1,1) > 0)
	{
		echo pg_result($option_exceptions,1,1);
		echo " services disabled";
	}
	else
	{
		echo "All services enabled";
	}
?>
	</td>
	<td>
<?php
	if(pg_result($option_exceptions,1,4) > 0)
	{
		echo pg_result($option_exceptions,1,4);
		echo " services disabled";
	}
	else
	{
		echo "All services enabled";
	}
?>
	</td>
</tr>
</table>

</body>
</html>
